searchData={"items":[{"type":"module","title":"Braintree","doc":"A native Braintree client library for Elixir. Only a subset of the API is\nsupported and this is a work in progress. That said, it is already used in\nproduction, and any modules that have been implemented can be used.\n\nFor general reference please see:\nhttps://developers.braintreepayments.com/reference/overview","ref":"Braintree.html"},{"type":"function","title":"Braintree.get_env/2","doc":"Convenience function for retrieving braintree specfic environment values, but\nwill raise an exception if values are missing.","ref":"Braintree.html#get_env/2"},{"type":"function","title":"Example - Braintree.get_env/2","doc":"iex> Braintree.get_env(:random_value)\n    ** (Braintree.ConfigError) missing config for :random_value\n\n    iex> Braintree.get_env(:random_value, \"random\")\n    \"random\"\n\n    iex> Application.put_env(:braintree, :random_value, \"not-random\")\n    ...> value = Braintree.get_env(:random_value)\n    ...> Application.delete_env(:braintree, :random_value)\n    ...> value\n    \"not-random\"\n\n    iex> System.put_env(\"RANDOM\", \"not-random\")\n    ...> Application.put_env(:braintree, :system_value, {:system, \"RANDOM\"})\n    ...> value = Braintree.get_env(:system_value)\n    ...> System.delete_env(\"RANDOM\")\n    ...> value\n    \"not-random\"","ref":"Braintree.html#get_env/2-example"},{"type":"function","title":"Braintree.put_env/2","doc":"Convenience function for setting `braintree` application environment\nvariables.","ref":"Braintree.html#put_env/2"},{"type":"function","title":"Example - Braintree.put_env/2","doc":"iex> Braintree.put_env(:thingy, \"thing\")\n    ...> Braintree.get_env(:thingy)\n    \"thing\"","ref":"Braintree.html#put_env/2-example"},{"type":"module","title":"Braintree.AddOn","doc":"Add-ons and discounts are created in the Control Panel. You cannot create or\nupdate them through the API.\n\nAdd-ons and discounts can be applied manually on a case-by-case basis, or you\ncan associate them with certain plans to apply them automatically to new\nsubscriptions. When creating a subscription, it will automatically inherit\nany add-ons and/or discounts associated with the plan. You can override those\ndetails at the time you create or update the subscription.","ref":"Braintree.AddOn.html"},{"type":"function","title":"Braintree.AddOn.all/1","doc":"Returns a list of Braintree::AddOn structs.","ref":"Braintree.AddOn.html#all/1"},{"type":"function","title":"Example - Braintree.AddOn.all/1","doc":"{:ok, addons} = Braintree.AddOns.all()","ref":"Braintree.AddOn.html#all/1-example"},{"type":"function","title":"Braintree.AddOn.new/1","doc":"","ref":"Braintree.AddOn.html#new/1"},{"type":"type","title":"Braintree.AddOn.t/0","doc":"","ref":"Braintree.AddOn.html#t:t/0"},{"type":"module","title":"Braintree.Address","doc":"You can create an address for a customer only although the structure\nis also used for a merchant account.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/request/address/create/ruby","ref":"Braintree.Address.html"},{"type":"function","title":"Braintree.Address.create/3","doc":"Create an address record, or return an error response after failed validation.","ref":"Braintree.Address.html#create/3"},{"type":"function","title":"Example - Braintree.Address.create/3","doc":"{:ok, address} = Braintree.Address.create(\"customer_id\", %{\n    first_name: \"Jenna\"\n  })\n\n  address.company # Braintree","ref":"Braintree.Address.html#create/3-example"},{"type":"function","title":"Braintree.Address.delete/3","doc":"You can delete an address using its customer ID and address ID.","ref":"Braintree.Address.html#delete/3"},{"type":"function","title":"Example - Braintree.Address.delete/3","doc":":ok = Braintree.Address.delete(\"customer_id\", \"address_id\")","ref":"Braintree.Address.html#delete/3-example"},{"type":"function","title":"Braintree.Address.find/3","doc":"If you want to look up a single address for a customer using the customer ID and\nthe address ID, use the find method.","ref":"Braintree.Address.html#find/3"},{"type":"function","title":"Example - Braintree.Address.find/3","doc":"address = Braintree.Address.find(\"customer_id\", \"address_id\")","ref":"Braintree.Address.html#find/3-example"},{"type":"function","title":"Braintree.Address.new/1","doc":"Convert a map into a Address struct.","ref":"Braintree.Address.html#new/1"},{"type":"function","title":"Example - Braintree.Address.new/1","doc":"address = Braintree.Address.new(%{\"company\" => \"Braintree\"})","ref":"Braintree.Address.html#new/1-example"},{"type":"type","title":"Braintree.Address.t/0","doc":"","ref":"Braintree.Address.html#t:t/0"},{"type":"function","title":"Braintree.Address.update/4","doc":"To update an address, use a customer's ID with an address's ID along with\nnew attributes. The same validations apply as when creating an address.\nAny attribute not passed will remain unchanged.","ref":"Braintree.Address.html#update/4"},{"type":"function","title":"Example - Braintree.Address.update/4","doc":"{:ok, address} = Braintree.Address.update(\"customer_id\", \"address_id\", %{\n      company: \"New Company Name\"\n    })\n\n    address.company # \"New Company Name\"","ref":"Braintree.Address.html#update/4-example"},{"type":"module","title":"Braintree.AndroidPayCard","doc":"AndroidPayCard structs are not created directly, but are built within\nresponses from other endpoints, such as `Braintree.Customer`.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/response/android-pay-card/ruby","ref":"Braintree.AndroidPayCard.html"},{"type":"function","title":"Braintree.AndroidPayCard.new/1","doc":"","ref":"Braintree.AndroidPayCard.html#new/1"},{"type":"type","title":"Braintree.AndroidPayCard.t/0","doc":"","ref":"Braintree.AndroidPayCard.html#t:t/0"},{"type":"module","title":"Braintree.ApplePayCard","doc":"ApplePayCard structs are not created directly, but are built within\nresponsees from other endpoints, such as `Braintree.Customer`.","ref":"Braintree.ApplePayCard.html"},{"type":"function","title":"Braintree.ApplePayCard.new/1","doc":"","ref":"Braintree.ApplePayCard.html#new/1"},{"type":"type","title":"Braintree.ApplePayCard.t/0","doc":"","ref":"Braintree.ApplePayCard.html#t:t/0"},{"type":"module","title":"Braintree.ClientToken","doc":"Generate a token required by the client SDK to communicate with Braintree.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/request/client-token/generate/ruby","ref":"Braintree.ClientToken.html"},{"type":"function","title":"Braintree.ClientToken.generate/2","doc":"Create a client token, or return an error response.","ref":"Braintree.ClientToken.html#generate/2"},{"type":"function","title":"Options - Braintree.ClientToken.generate/2","doc":"* `:version` - The default value is 2. Current supported versions are 1, 2,\n  and 3. Please check your client-side SDKs in use before changing this\n  value.","ref":"Braintree.ClientToken.html#generate/2-options"},{"type":"function","title":"Example - Braintree.ClientToken.generate/2","doc":"{:ok, token} = Braintree.ClientToken.generate()\n\nGenerate a specific token version:\n\n    {:ok, token} = Braintree.ClientToken.generate(%{version: 3})","ref":"Braintree.ClientToken.html#generate/2-example"},{"type":"module","title":"Braintree.Construction","doc":"This module provides a `use` macro to help convert raw HTTP responses into\nstructs.","ref":"Braintree.Construction.html"},{"type":"function","title":"Braintree.Construction.new/2","doc":"Convert a response into one or more typed structs.","ref":"Braintree.Construction.html#new/2"},{"type":"module","title":"Braintree.CreditCard","doc":"CreditCard structs are not created directly, but are built within\nresponsees from other endpoints, such as `Braintree.Customer`.","ref":"Braintree.CreditCard.html"},{"type":"function","title":"Braintree.CreditCard.new/1","doc":"","ref":"Braintree.CreditCard.html#new/1"},{"type":"type","title":"Braintree.CreditCard.t/0","doc":"","ref":"Braintree.CreditCard.html#t:t/0"},{"type":"module","title":"Braintree.CreditCardVerification","doc":"Manage credit card verifications.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/response/credit-card-verification/ruby","ref":"Braintree.CreditCardVerification.html"},{"type":"function","title":"Braintree.CreditCardVerification.new/1","doc":"Convert a map into a CreditCardVerification struct.","ref":"Braintree.CreditCardVerification.html#new/1"},{"type":"function","title":"Example - Braintree.CreditCardVerification.new/1","doc":"verification = Braintree.CreditCardVerification.new(%{\"credit_card_card_type\" => \"Visa\"})","ref":"Braintree.CreditCardVerification.html#new/1-example"},{"type":"function","title":"Braintree.CreditCardVerification.search/2","doc":"To search for credit card verifications, pass a map of search parameters.","ref":"Braintree.CreditCardVerification.html#search/2"},{"type":"function","title":"Example: - Braintree.CreditCardVerification.search/2","doc":"search_params = %{amount: %{min: \"10.0\", max: \"15.0\"},\n                    status: [\"approved\", \"pending\"]}\n\n  {:ok, verifications} = Braintree.CreditCardVerification.search(search_params)","ref":"Braintree.CreditCardVerification.html#search/2-example"},{"type":"type","title":"Braintree.CreditCardVerification.t/0","doc":"","ref":"Braintree.CreditCardVerification.html#t:t/0"},{"type":"module","title":"Braintree.Customer","doc":"You can create a customer by itself, with a payment method, or with a\ncredit card with a billing address.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/request/customer/create/ruby","ref":"Braintree.Customer.html"},{"type":"function","title":"Braintree.Customer.create/2","doc":"Create a customer record, or return an error response with after failed\nvalidation.","ref":"Braintree.Customer.html#create/2"},{"type":"function","title":"Example - Braintree.Customer.create/2","doc":"{:ok, customer} = Braintree.Customer.create(%{\n      first_name: \"Jen\",\n      last_name: \"Smith\",\n      company: \"Braintree\",\n      email: \"jen@example.com\",\n      phone: \"312.555.1234\",\n      fax: \"614.555.5678\",\n      website: \"www.example.com\"\n    })\n\n    customer.company # Braintree","ref":"Braintree.Customer.html#create/2-example"},{"type":"function","title":"Braintree.Customer.delete/2","doc":"You can delete a customer using its ID. When a customer is deleted, all\nassociated payment methods are also deleted, and all associated recurring\nbilling subscriptions are canceled.","ref":"Braintree.Customer.html#delete/2"},{"type":"function","title":"Example - Braintree.Customer.delete/2","doc":":ok = Braintree.Customer.delete(\"customer_id\")","ref":"Braintree.Customer.html#delete/2-example"},{"type":"function","title":"Braintree.Customer.find/2","doc":"If you want to look up a single customer using its ID, use the find method.","ref":"Braintree.Customer.html#find/2"},{"type":"function","title":"Example - Braintree.Customer.find/2","doc":"customer = Braintree.Customer.find(\"customer_id\")","ref":"Braintree.Customer.html#find/2-example"},{"type":"function","title":"Braintree.Customer.new/1","doc":"Convert a map into a Company struct along with nested payment options. Credit\ncards and paypal accounts are converted to a list of structs as well.","ref":"Braintree.Customer.html#new/1"},{"type":"function","title":"Example - Braintree.Customer.new/1","doc":"customer = Braintree.Customer.new(%{\"company\" => \"Soren\",\n                                        \"email\" => \"parker@example.com\"})","ref":"Braintree.Customer.html#new/1-example"},{"type":"function","title":"Braintree.Customer.search/2","doc":"To search for customers, pass a map of search parameters.","ref":"Braintree.Customer.html#search/2"},{"type":"function","title":"Example: - Braintree.Customer.search/2","doc":"{:ok, customers} = Braintree.Customer.search(%{first_name: %{is: \"Jenna\"}})","ref":"Braintree.Customer.html#search/2-example"},{"type":"type","title":"Braintree.Customer.t/0","doc":"","ref":"Braintree.Customer.html#t:t/0"},{"type":"function","title":"Braintree.Customer.update/3","doc":"To update a customer, use its ID along with new attributes. The same\nvalidations apply as when creating a customer. Any attribute not passed will\nremain unchanged.","ref":"Braintree.Customer.html#update/3"},{"type":"function","title":"Example - Braintree.Customer.update/3","doc":"{:ok, customer} = Braintree.Customer.update(\"customer_id\", %{\n      company: \"New Company Name\"\n    })\n\n    customer.company # \"New Company Name\"","ref":"Braintree.Customer.html#update/3-example"},{"type":"module","title":"Braintree.Discount","doc":"Add-ons and discounts are created in the Control Panel. You cannot create or update them through the API.\n\nAdd-ons and discounts can be applied manually on a case-by-case\nbasis, or you can associate them with certain plans to apply them\nautomatically to new subscriptions. When creating a subscription,\nit will automatically inherit any add-ons and/or discounts\nassociated with the plan. You can override those details at the\ntime you create or update the subscription.","ref":"Braintree.Discount.html"},{"type":"function","title":"Braintree.Discount.all/1","doc":"Returns a collection of Braintree::Discount objects.","ref":"Braintree.Discount.html#all/1"},{"type":"function","title":"Example - Braintree.Discount.all/1","doc":"{:ok, discounts} = Braintree.Discount.all()","ref":"Braintree.Discount.html#all/1-example"},{"type":"function","title":"Braintree.Discount.new/1","doc":"","ref":"Braintree.Discount.html#new/1"},{"type":"type","title":"Braintree.Discount.t/0","doc":"","ref":"Braintree.Discount.html#t:t/0"},{"type":"module","title":"Braintree.ErrorResponse","doc":"A general purpose response wrapper that is built for any failed API\nresponse.\n\nSee the following pages for details about the various processor responses:\n\n* https://developers.braintreepayments.com/reference/general/processor-responses/authorization-responses\n* https://developers.braintreepayments.com/reference/general/processor-responses/settlement-responses\n* https://developers.braintreepayments.com/reference/general/processor-responses/avs-cvv-responses","ref":"Braintree.ErrorResponse.html"},{"type":"function","title":"Braintree.ErrorResponse.new/1","doc":"","ref":"Braintree.ErrorResponse.html#new/1"},{"type":"type","title":"Braintree.ErrorResponse.t/0","doc":"","ref":"Braintree.ErrorResponse.html#t:t/0"},{"type":"module","title":"Braintree.HTTP","doc":"Base client for all server interaction, used by all endpoint specific\nmodules.\n\nThis request wrapper coordinates the remote server, headers, authorization\nand SSL options.\n\nUsing `Braintree.HTTP` requires the presence of three config values:\n\n* `merchant_id` - Braintree merchant id\n* `private_key` - Braintree private key\n* `public_key` - Braintree public key\n\nAll three values must be set or a `Braintree.ConfigError` will be raised at\nruntime. All those config values support the `{:system, \"VAR_NAME\"}` as a\nvalue - in which case the value will be read from the system environment with\n`System.get_env(\"VAR_NAME\")`.","ref":"Braintree.HTTP.html"},{"type":"function","title":"Braintree.HTTP.delete/1","doc":"","ref":"Braintree.HTTP.html#delete/1"},{"type":"function","title":"Braintree.HTTP.delete/2","doc":"","ref":"Braintree.HTTP.html#delete/2"},{"type":"function","title":"Braintree.HTTP.delete/3","doc":"","ref":"Braintree.HTTP.html#delete/3"},{"type":"type","title":"Braintree.HTTP.error/0","doc":"","ref":"Braintree.HTTP.html#t:error/0"},{"type":"function","title":"Braintree.HTTP.get/1","doc":"","ref":"Braintree.HTTP.html#get/1"},{"type":"function","title":"Braintree.HTTP.get/2","doc":"","ref":"Braintree.HTTP.html#get/2"},{"type":"function","title":"Braintree.HTTP.get/3","doc":"","ref":"Braintree.HTTP.html#get/3"},{"type":"function","title":"Braintree.HTTP.post/1","doc":"","ref":"Braintree.HTTP.html#post/1"},{"type":"function","title":"Braintree.HTTP.post/2","doc":"","ref":"Braintree.HTTP.html#post/2"},{"type":"function","title":"Braintree.HTTP.post/3","doc":"","ref":"Braintree.HTTP.html#post/3"},{"type":"function","title":"Braintree.HTTP.put/1","doc":"","ref":"Braintree.HTTP.html#put/1"},{"type":"function","title":"Braintree.HTTP.put/2","doc":"","ref":"Braintree.HTTP.html#put/2"},{"type":"function","title":"Braintree.HTTP.put/3","doc":"","ref":"Braintree.HTTP.html#put/3"},{"type":"function","title":"Braintree.HTTP.request/4","doc":"Centralized request handling function. All convenience structs use this\nfunction to interact with the Braintree servers. This function can be used\ndirectly to supplement missing functionality.","ref":"Braintree.HTTP.html#request/4"},{"type":"function","title":"Example - Braintree.HTTP.request/4","doc":"defmodule MyApp.Disbursement do\n      alias Braintree.HTTP\n\n      def disburse(params \\ %{}) do\n        HTTP.request(:get, \"disbursements\", params)\n      end\n    end","ref":"Braintree.HTTP.html#request/4-example"},{"type":"type","title":"Braintree.HTTP.response/0","doc":"","ref":"Braintree.HTTP.html#t:response/0"},{"type":"module","title":"Braintree.Merchant.Account","doc":"Represents a merchant account in a marketplace.\n\nFor additional reference, see:\nhttps://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Account.html"},{"type":"function","title":"Braintree.Merchant.Account.create/2","doc":"Create a merchant account or return an error response after failed validation","ref":"Braintree.Merchant.Account.html#create/2"},{"type":"function","title":"Example - Braintree.Merchant.Account.create/2","doc":"{:ok, merchant} = Braintree.Merchant.Account.create(%{\n    tos_accepted: true,\n  })","ref":"Braintree.Merchant.Account.html#create/2-example"},{"type":"function","title":"Braintree.Merchant.Account.find/2","doc":"If you want to look up a single merchant using ID, use the find method.","ref":"Braintree.Merchant.Account.html#find/2"},{"type":"function","title":"Example - Braintree.Merchant.Account.find/2","doc":"merchant = Braintree.Merchant.find(\"merchant_id\")","ref":"Braintree.Merchant.Account.html#find/2-example"},{"type":"function","title":"Braintree.Merchant.Account.new/1","doc":"Convert a map into a `Braintree.Merchant.Account` struct.","ref":"Braintree.Merchant.Account.html#new/1"},{"type":"type","title":"Braintree.Merchant.Account.t/0","doc":"","ref":"Braintree.Merchant.Account.html#t:t/0"},{"type":"function","title":"Braintree.Merchant.Account.update/3","doc":"To update a merchant, use its ID along with new attributes.\nThe same validations apply as when creating a merchant.\nAny attribute not passed will remain unchanged.","ref":"Braintree.Merchant.Account.html#update/3"},{"type":"function","title":"Example - Braintree.Merchant.Account.update/3","doc":"{:ok, merchant} = Braintree.Merchant.update(\"merchant_id\", %{\n      funding_details: %{account_number: \"1234567890\"}\n    })\n\n    merchant.funding_details.account_number # \"1234567890\"","ref":"Braintree.Merchant.Account.html#update/3-example"},{"type":"module","title":"Braintree.Merchant.Business","doc":"Represents the business section of a merchant account.\n\nFor additional reference, see:\nhttps://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Business.html"},{"type":"function","title":"Braintree.Merchant.Business.new/1","doc":"","ref":"Braintree.Merchant.Business.html#new/1"},{"type":"type","title":"Braintree.Merchant.Business.t/0","doc":"","ref":"Braintree.Merchant.Business.html#t:t/0"},{"type":"module","title":"Braintree.Merchant.Funding","doc":"Represents the funding section of a merchant account.\n\nFor additional reference, see:\nhttps://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Funding.html"},{"type":"function","title":"Braintree.Merchant.Funding.new/1","doc":"","ref":"Braintree.Merchant.Funding.html#new/1"},{"type":"type","title":"Braintree.Merchant.Funding.t/0","doc":"","ref":"Braintree.Merchant.Funding.html#t:t/0"},{"type":"module","title":"Braintree.Merchant.Individual","doc":"Represents the individual section of a merchant account.\n\nFor additional reference, see:\nhttps://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Individual.html"},{"type":"function","title":"Braintree.Merchant.Individual.new/1","doc":"","ref":"Braintree.Merchant.Individual.html#new/1"},{"type":"type","title":"Braintree.Merchant.Individual.t/0","doc":"","ref":"Braintree.Merchant.Individual.html#t:t/0"},{"type":"module","title":"Braintree.PaymentMethod","doc":"Create, update, find and delete payment methods. Payment methods\nmay be a `CreditCard` or a `PaypalAccount`.","ref":"Braintree.PaymentMethod.html"},{"type":"function","title":"Braintree.PaymentMethod.create/2","doc":"Create a payment method record, or return an error response with after failed\nvalidation.","ref":"Braintree.PaymentMethod.html#create/2"},{"type":"function","title":"Example - Braintree.PaymentMethod.create/2","doc":"{:ok, customer} = Braintree.Customer.create(%{\n      first_name: \"Jen\",\n      last_name: \"Smith\"\n    })\n\n    {:ok, credit_card} = Braintree.PaymentMethod.create(%{\n      customer_id: customer.id,\n      payment_method_nonce: Braintree.Testing.Nonces.transactable\n    })\n\n    credit_card.type # \"Visa\"","ref":"Braintree.PaymentMethod.html#create/2-example"},{"type":"function","title":"Braintree.PaymentMethod.delete/2","doc":"Delete a payment method record, or return an error response if token invalid","ref":"Braintree.PaymentMethod.html#delete/2"},{"type":"function","title":"Example - Braintree.PaymentMethod.delete/2","doc":"{:ok, \"Success\"} = Braintree.PaymentMethod.delete(token)","ref":"Braintree.PaymentMethod.html#delete/2-example"},{"type":"function","title":"Braintree.PaymentMethod.find/2","doc":"Find a payment method record, or return an error response if token invalid","ref":"Braintree.PaymentMethod.html#find/2"},{"type":"function","title":"Example - Braintree.PaymentMethod.find/2","doc":"{:ok, payment_method} = Braintree.PaymentMethod.find(token)\n\n    payment_method.type # CreditCard","ref":"Braintree.PaymentMethod.html#find/2-example"},{"type":"function","title":"Braintree.PaymentMethod.update/3","doc":"Update a payment method record, or return an error response with after failed\nvalidation.","ref":"Braintree.PaymentMethod.html#update/3"},{"type":"function","title":"Example - Braintree.PaymentMethod.update/3","doc":"{:ok, customer} = Braintree.Customer.create(%{\n      first_name: \"Jen\",\n      last_name: \"Smith\"\n    })\n\n    {:ok, credit_card} = Braintree.PaymentMethod.create(%{\n      customer_id: customer.id,\n      cardholder_name: \"CH Name\",\n      payment_method_nonce: Braintree.Testing.Nonces.transactable\n    })\n\n    {:ok, payment_method} = Braintree.PaymentMethod.update(\n      credit_card.token,\n      %{cardholder_name: \"NEW\"}\n    )\n\n    payment_method.cardholder_name # \"NEW\"","ref":"Braintree.PaymentMethod.html#update/3-example"},{"type":"module","title":"Braintree.PaymentMethodNonce","doc":"Create a payment method nonce from an existing payment method token","ref":"Braintree.PaymentMethodNonce.html"},{"type":"function","title":"Braintree.PaymentMethodNonce.create/2","doc":"Create a payment method nonce from `token`","ref":"Braintree.PaymentMethodNonce.html#create/2"},{"type":"function","title":"Example - Braintree.PaymentMethodNonce.create/2","doc":"{:ok, payment_method_nonce} = Braintree.PaymentMethodNonce.create(token)\n\n    payment_method_nonce.nonce","ref":"Braintree.PaymentMethodNonce.html#create/2-example"},{"type":"function","title":"Braintree.PaymentMethodNonce.find/2","doc":"Find a payment method nonce, or return an error response if token invalid","ref":"Braintree.PaymentMethodNonce.html#find/2"},{"type":"function","title":"Example - Braintree.PaymentMethodNonce.find/2","doc":"{:ok, payment_method} = Braintree.PaymentMethodNonce.find(token)\n\n    payment_method.type #CreditCard","ref":"Braintree.PaymentMethodNonce.html#find/2-example"},{"type":"type","title":"Braintree.PaymentMethodNonce.t/0","doc":"","ref":"Braintree.PaymentMethodNonce.html#t:t/0"},{"type":"module","title":"Braintree.PaypalAccount","doc":"Find, update and delete Paypal Accounts using PaymentMethod token","ref":"Braintree.PaypalAccount.html"},{"type":"function","title":"Braintree.PaypalAccount.delete/2","doc":"Delete a paypal account record using `token` or return an error\nresponse if the token is invalid.","ref":"Braintree.PaypalAccount.html#delete/2"},{"type":"function","title":"Example - Braintree.PaypalAccount.delete/2","doc":"{:ok, paypal_account} = Braintree.PaypalAccount.delete(token)","ref":"Braintree.PaypalAccount.html#delete/2-example"},{"type":"function","title":"Braintree.PaypalAccount.find/2","doc":"Find a paypal account record using `token` or return an error\nresponse if the token is invalid.","ref":"Braintree.PaypalAccount.html#find/2"},{"type":"function","title":"Example - Braintree.PaypalAccount.find/2","doc":"{:ok, paypal_account} = Braintree.PaypalAccount.find(token)","ref":"Braintree.PaypalAccount.html#find/2-example"},{"type":"function","title":"Braintree.PaypalAccount.new/1","doc":"","ref":"Braintree.PaypalAccount.html#new/1"},{"type":"type","title":"Braintree.PaypalAccount.t/0","doc":"","ref":"Braintree.PaypalAccount.html#t:t/0"},{"type":"function","title":"Braintree.PaypalAccount.update/3","doc":"Update a paypal account record using `token` or return an error\nresponse if the token is invalid.","ref":"Braintree.PaypalAccount.html#update/3"},{"type":"function","title":"Example - Braintree.PaypalAccount.update/3","doc":"{:ok, paypal_account} = Braintree.PaypalAccount.update(\n      token,\n      %{options: %{make_default: true}\n    )","ref":"Braintree.PaypalAccount.html#update/3-example"},{"type":"module","title":"Braintree.Plan","doc":"Plans represent recurring billing plans in a Braintree merchant account.\nThe API for plans is read only.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/request/plan/all/ruby","ref":"Braintree.Plan.html"},{"type":"function","title":"Braintree.Plan.all/1","doc":"Get a list of all the plans defined in the merchant account. If there are\nno plans an empty list is returned.","ref":"Braintree.Plan.html#all/1"},{"type":"function","title":"Example - Braintree.Plan.all/1","doc":"{:ok, plans} = Braintree.Plan.all()","ref":"Braintree.Plan.html#all/1-example"},{"type":"function","title":"Braintree.Plan.create/2","doc":"Create a new plan under a merchant account.","ref":"Braintree.Plan.html#create/2"},{"type":"function","title":"Example - Braintree.Plan.create/2","doc":"{:ok, plan} = Braintree.Plan.create(%{\n      name: \"a plan\",\n      billing_frequency: 3,\n      currency_iso_code: \"USD\",\n      price: \"10.00\"\n    })","ref":"Braintree.Plan.html#create/2-example"},{"type":"function","title":"Braintree.Plan.delete/2","doc":"Delete a plan defined in the merchant account by the plan id.\nA plan can't be deleted if it has any former or current subscriptions associated with it.\nIf there is no plan with the specified id, `{:error, :not_found}` is returned.","ref":"Braintree.Plan.html#delete/2"},{"type":"function","title":"Braintree.Plan.find/2","doc":"Get a specific plan defined in the merchant account by the plan id. If there is\nno plan with the specified id, `{:error, :not_found}` is returned.","ref":"Braintree.Plan.html#find/2"},{"type":"function","title":"Example - Braintree.Plan.find/2","doc":"{:ok, plan} = Braintree.Plan.find(\"existing plan_id\")\n\n    {:error, :not_found} = Braintree.Plan.find(\"non-existing plan_id\")","ref":"Braintree.Plan.html#find/2-example"},{"type":"function","title":"Braintree.Plan.new/1","doc":"","ref":"Braintree.Plan.html#new/1"},{"type":"type","title":"Braintree.Plan.t/0","doc":"","ref":"Braintree.Plan.html#t:t/0"},{"type":"function","title":"Braintree.Plan.update/3","doc":"Updates a specific plan defined in the merchant account by the plan id. If there is\nno plan with the specified id, `{:error, :not_found}` is returned.","ref":"Braintree.Plan.html#update/3"},{"type":"function","title":"Example - Braintree.Plan.update/3","doc":"{:ok, updated_plan} = Braintree.Plan.find(\"existing plan_id\", %{name: \"new_name\"})\n\n    {:error, :not_found} = Braintree.Plan.find(\"non-existing plan_id\")","ref":"Braintree.Plan.html#update/3-example"},{"type":"module","title":"Braintree.Search","doc":"This module performs advanced search on a resource.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/general/searching/search-fields/ruby","ref":"Braintree.Search.html"},{"type":"function","title":"Braintree.Search.perform/4","doc":"Perform an advanced search on a given resource and create new structs\nbased on the initializer given.","ref":"Braintree.Search.html#perform/4"},{"type":"function","title":"Example - Braintree.Search.perform/4","doc":"search_params = %{first_name: %{is: \"Jenna\"}}\n  {:ok, customers} = Braintree.Search.perform(search_params, \"customers\", &Braintree.Customer.new/1)","ref":"Braintree.Search.html#perform/4-example"},{"type":"module","title":"Braintree.SettlementBatchSummary","doc":"The settlement batch summary displays the total sales and credits for each\nbatch for a particular date. The transactions can be grouped by a single\ncustom field's values.\n\nhttps://developers.braintreepayments.com/reference/request/settlement-batch-summary/generate/ruby","ref":"Braintree.SettlementBatchSummary.html"},{"type":"function","title":"Braintree.SettlementBatchSummary.generate/3","doc":"Generate a report of all settlements for a particular date. The\nfield used for custom grouping will always be set as\n`custom_field`, regardless of its name.","ref":"Braintree.SettlementBatchSummary.html#generate/3"},{"type":"function","title":"Example - Braintree.SettlementBatchSummary.generate/3","doc":"Braintree.SettlementBatchSummary(\"2016-9-5\", \"custom_field_1\")","ref":"Braintree.SettlementBatchSummary.html#generate/3-example"},{"type":"function","title":"Braintree.SettlementBatchSummary.new/1","doc":"Convert a map including records into a summary struct with a list\nof record structs.","ref":"Braintree.SettlementBatchSummary.html#new/1"},{"type":"type","title":"Braintree.SettlementBatchSummary.t/0","doc":"","ref":"Braintree.SettlementBatchSummary.html#t:t/0"},{"type":"module","title":"Braintree.SettlementBatchSummary.Record","doc":"A record contains details for a transaction in a summary.","ref":"Braintree.SettlementBatchSummary.Record.html"},{"type":"function","title":"Braintree.SettlementBatchSummary.Record.new/1","doc":"Convert a list of records into structs, including any custom fields that\nwere used as the grouping value.","ref":"Braintree.SettlementBatchSummary.Record.html#new/1"},{"type":"type","title":"Braintree.SettlementBatchSummary.Record.t/0","doc":"","ref":"Braintree.SettlementBatchSummary.Record.html#t:t/0"},{"type":"module","title":"Braintree.Subscription","doc":"Manage customer subscriptions to recurring billing plans.\n\nFor additional reference see:\nhttps://developers.braintreepayments.com/reference/request/subscription/create/ruby","ref":"Braintree.Subscription.html"},{"type":"function","title":"Braintree.Subscription.cancel/2","doc":"Cancel an existing subscription by `subscription_id`. A cancelled subscription\ncannot be reactivated, you would need to create a new one.","ref":"Braintree.Subscription.html#cancel/2"},{"type":"function","title":"Example - Braintree.Subscription.cancel/2","doc":"{:ok, subscription} = Subscription.cancel(\"123\")","ref":"Braintree.Subscription.html#cancel/2-example"},{"type":"function","title":"Braintree.Subscription.create/2","doc":"Create a subscription, or return an error response with after failed\nvalidation.","ref":"Braintree.Subscription.html#create/2"},{"type":"function","title":"Example - Braintree.Subscription.create/2","doc":"{:ok, sub} = Braintree.Subscription.create(%{\n      payment_method_token: card.token,\n      plan_id: \"starter\"\n    })","ref":"Braintree.Subscription.html#create/2-example"},{"type":"function","title":"Braintree.Subscription.find/2","doc":"Find an existing subscription by `subscription_id`","ref":"Braintree.Subscription.html#find/2"},{"type":"function","title":"Example - Braintree.Subscription.find/2","doc":"{:ok, subscription} = Subscription.find(\"123\")","ref":"Braintree.Subscription.html#find/2-example"},{"type":"function","title":"Braintree.Subscription.new/1","doc":"Convert a map into a Subscription struct. Add_ons and transactions\nare converted to a list of structs as well.","ref":"Braintree.Subscription.html#new/1"},{"type":"function","title":"Example - Braintree.Subscription.new/1","doc":"subscripton = Braintree.Subscription.new(%{\"plan_id\" => \"business\",\n                                               \"status\" => \"Active\"})","ref":"Braintree.Subscription.html#new/1-example"},{"type":"function","title":"Braintree.Subscription.retry_charge/3","doc":"You can manually retry charging past due subscriptions.\n\nBy default, we will use the subscription balance when retrying the\ntransaction. If you would like to use a different amount you can optionally\nspecify the amount for the transaction.\n\nA successful manual retry of a past due subscription will **always** reduce\nthe balance of that subscription to $0, regardless of the amount of the\nretry.","ref":"Braintree.Subscription.html#retry_charge/3"},{"type":"function","title":"Example - Braintree.Subscription.retry_charge/3","doc":"{:ok, transaction} = Braintree.Subscription.retry_charge(sub_id)\n    {:ok, transaction} = Braintree.Subscription.retry_charge(sub_id, \"24.00\")","ref":"Braintree.Subscription.html#retry_charge/3-example"},{"type":"function","title":"Braintree.Subscription.search/2","doc":"To search for subscriptions, pass a map of search parameters.","ref":"Braintree.Subscription.html#search/2"},{"type":"function","title":"Example: - Braintree.Subscription.search/2","doc":"{:ok, subscriptions} = Braintree.Subscription.search(%{plan_id: %{is: \"starter\"}})","ref":"Braintree.Subscription.html#search/2-example"},{"type":"type","title":"Braintree.Subscription.t/0","doc":"","ref":"Braintree.Subscription.html#t:t/0"},{"type":"function","title":"Braintree.Subscription.update/3","doc":"To update a subscription, use its ID along with new attributes. The same\nvalidations apply as when creating a subscription. Any attribute not passed will\nremain unchanged.","ref":"Braintree.Subscription.html#update/3"},{"type":"function","title":"Example - Braintree.Subscription.update/3","doc":"{:ok, subscription} = Braintree.Subscription.update(\"subscription_id\", %{\n      plan_id: \"new_plan_id\"\n    })\n    subscription.plan_id # \"new_plan_id\"","ref":"Braintree.Subscription.html#update/3-example"},{"type":"module","title":"Braintree.Testing.CreditCardNumbers","doc":"The functions contained in this module provide credit card numbers that\nshould be used when working in the sandbox environment. The sandbox will not\naccept any credit card numbers other than the ones listed below.\n\nSee http://www.braintreepayments.com/docs/ruby/reference/sandbox","ref":"Braintree.Testing.CreditCardNumbers.html"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.all/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#all/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.am_exes/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#am_exes/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.carte_blanches/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#carte_blanches/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.diners_clubs/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#diners_clubs/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.discovers/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#discovers/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.jcbs/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#jcbs/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.master_cards/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#master_cards/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.unknowns/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#unknowns/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.visas/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#visas/0"},{"type":"module","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification","doc":"These are vendor specific numbers that will always fail verification.","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.all/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#all/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.am_ex/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#am_ex/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.discover/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#discover/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.master_card/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#master_card/0"},{"type":"function","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.visa/0","doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#visa/0"},{"type":"module","title":"Braintree.Testing.Nonces","doc":"A collection of static payment nonces provided to simplify testing server\nside code.\n\nNonces are preferred over credit card numbers when testing payment methods.\nOnly a subset of nonces are defined here, for the full list see the sandbox\ndocumentation about [payment method nonces][pmn].\n\n[pmn]: https://developers.braintreepayments.com/reference/general/testing/ruby#payment-method-nonces","ref":"Braintree.Testing.Nonces.html"},{"type":"function","title":"Braintree.Testing.Nonces.abstract_transactable/0","doc":"","ref":"Braintree.Testing.Nonces.html#abstract_transactable/0"},{"type":"function","title":"Braintree.Testing.Nonces.android_pay_amex_nonce/0","doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_amex_nonce/0"},{"type":"function","title":"Braintree.Testing.Nonces.android_pay_discover_nonce/0","doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_discover_nonce/0"},{"type":"function","title":"Braintree.Testing.Nonces.android_pay_mastercard_nonce/0","doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_mastercard_nonce/0"},{"type":"function","title":"Braintree.Testing.Nonces.android_pay_visa_nonce/0","doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_visa_nonce/0"},{"type":"function","title":"Braintree.Testing.Nonces.apple_pay_am_ex/0","doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_am_ex/0"},{"type":"function","title":"Braintree.Testing.Nonces.apple_pay_master_card/0","doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_master_card/0"},{"type":"function","title":"Braintree.Testing.Nonces.apple_pay_visa/0","doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_visa/0"},{"type":"function","title":"Braintree.Testing.Nonces.coinbase/0","doc":"","ref":"Braintree.Testing.Nonces.html#coinbase/0"},{"type":"function","title":"Braintree.Testing.Nonces.consumed/0","doc":"","ref":"Braintree.Testing.Nonces.html#consumed/0"},{"type":"function","title":"Braintree.Testing.Nonces.paypal_future_payment/0","doc":"","ref":"Braintree.Testing.Nonces.html#paypal_future_payment/0"},{"type":"function","title":"Braintree.Testing.Nonces.transactable/0","doc":"","ref":"Braintree.Testing.Nonces.html#transactable/0"},{"type":"function","title":"Braintree.Testing.Nonces.venmo_account/0","doc":"","ref":"Braintree.Testing.Nonces.html#venmo_account/0"},{"type":"module","title":"Braintree.Testing.TestTransaction","doc":"Create transactions for testing purposes only.\n\nTransition to settled, settlement_confirmed, or settlement_declined states.","ref":"Braintree.Testing.TestTransaction.html"},{"type":"function","title":"Braintree.Testing.TestTransaction.settle/1","doc":"Use a `transaction_id` to transition to settled status. This\nallows for testing of refunds.","ref":"Braintree.Testing.TestTransaction.html#settle/1"},{"type":"function","title":"Example - Braintree.Testing.TestTransaction.settle/1","doc":"{:ok, transaction} = TestTransaction.settle(transaction_id: \"123\")\n\ntransaction.status # \"settled\"","ref":"Braintree.Testing.TestTransaction.html#settle/1-example"},{"type":"function","title":"Braintree.Testing.TestTransaction.settlement_confirm/1","doc":"Use a `transaction_id` to transition to settled_confirmed status","ref":"Braintree.Testing.TestTransaction.html#settlement_confirm/1"},{"type":"function","title":"Example - Braintree.Testing.TestTransaction.settlement_confirm/1","doc":"{:ok, transaction} = TestTransaction.settlement_confirm(\ntransaction_id: \"123\")\n\ntransaction.status # \"settlement_confirmed\"","ref":"Braintree.Testing.TestTransaction.html#settlement_confirm/1-example"},{"type":"function","title":"Braintree.Testing.TestTransaction.settlement_decline/1","doc":"Use a `transaction_id` to transition to settlement_declined status","ref":"Braintree.Testing.TestTransaction.html#settlement_decline/1"},{"type":"function","title":"Example - Braintree.Testing.TestTransaction.settlement_decline/1","doc":"{:ok, transaction} = TestTransaction.settlement_decline(\ntransaction_id: \"123\")\n\ntransaction.status # \"settlement_declined\"","ref":"Braintree.Testing.TestTransaction.html#settlement_decline/1-example"},{"type":"module","title":"Braintree.Transaction","doc":"Create a new sale.\n\nTo create a transaction, you must include an amount and either a\npayment_method_nonce or a payment_method_token.\n\nhttps://developers.braintreepayments.com/reference/response/transaction/ruby","ref":"Braintree.Transaction.html"},{"type":"function","title":"Braintree.Transaction.find/2","doc":"Find an existing transaction by `transaction_id`","ref":"Braintree.Transaction.html#find/2"},{"type":"function","title":"Example - Braintree.Transaction.find/2","doc":"{:ok, transaction} = Transaction.find(\"123\")","ref":"Braintree.Transaction.html#find/2-example"},{"type":"function","title":"Braintree.Transaction.new/1","doc":"Convert a map into a Transaction struct.\n\nAdd_ons are converted to a list of structs as well.","ref":"Braintree.Transaction.html#new/1"},{"type":"function","title":"Example - Braintree.Transaction.new/1","doc":"transaction =\n  Braintree.Transaction.new(%{\n    \"subscription_id\" => \"subxid\",\n    \"status\" => \"submitted_for_settlement\"\n  })","ref":"Braintree.Transaction.html#new/1-example"},{"type":"function","title":"Braintree.Transaction.refund/3","doc":"Use a `transaction_id` and optional `amount` to issue a refund\nfor that transaction","ref":"Braintree.Transaction.html#refund/3"},{"type":"function","title":"Example - Braintree.Transaction.refund/3","doc":"{:ok, transaction} = Transaction.refund(\"123\", %{amount: \"100.00\"})\n\n    transaction.status # \"refunded\"","ref":"Braintree.Transaction.html#refund/3-example"},{"type":"function","title":"Braintree.Transaction.sale/2","doc":"Use a `payment_method_nonce` or `payment_method_token` to make a one time\ncharge against a payment method.","ref":"Braintree.Transaction.html#sale/2"},{"type":"function","title":"Example - Braintree.Transaction.sale/2","doc":"{:ok, transaction} = Transaction.sale(%{\n      amount: \"100.00\",\n      payment_method_nonce: @payment_method_nonce,\n      options: %{submit_for_settlement: true}\n    })\n\n    transaction.status # \"settling\"","ref":"Braintree.Transaction.html#sale/2-example"},{"type":"function","title":"Braintree.Transaction.submit_for_settlement/3","doc":"Use a `transaction_id` and optional `amount` to settle the transaction.\nUse this if `submit_for_settlement` was false while creating the charge using sale.","ref":"Braintree.Transaction.html#submit_for_settlement/3"},{"type":"function","title":"Example - Braintree.Transaction.submit_for_settlement/3","doc":"{:ok, transaction} = Transaction.submit_for_settlement(\"123\", %{amount: \"100\"})\n    transaction.status # \"settling\"","ref":"Braintree.Transaction.html#submit_for_settlement/3-example"},{"type":"type","title":"Braintree.Transaction.t/0","doc":"","ref":"Braintree.Transaction.html#t:t/0"},{"type":"function","title":"Braintree.Transaction.void/2","doc":"Use a `transaction_id` to issue a void for that transaction","ref":"Braintree.Transaction.html#void/2"},{"type":"function","title":"Example - Braintree.Transaction.void/2","doc":"{:ok, transaction} = Transaction.void(\"123\")\n\n    transaction.status # \"voided\"","ref":"Braintree.Transaction.html#void/2-example"},{"type":"module","title":"Braintree.TransactionLineItem","doc":"For fetching line items for a given transaction.\n\nhttps://developers.braintreepayments.com/reference/response/transaction-line-item/ruby","ref":"Braintree.TransactionLineItem.html"},{"type":"function","title":"Braintree.TransactionLineItem.find_all/2","doc":"Find transaction line items for the given transaction id.","ref":"Braintree.TransactionLineItem.html#find_all/2"},{"type":"function","title":"Example - Braintree.TransactionLineItem.find_all/2","doc":"{:ok, transaction_line_items} = TransactionLineItem.find(\"123\")","ref":"Braintree.TransactionLineItem.html#find_all/2-example"},{"type":"function","title":"Braintree.TransactionLineItem.new/1","doc":"Converts a list of transaction line item maps into a list of transaction line items.","ref":"Braintree.TransactionLineItem.html#new/1"},{"type":"function","title":"Example - Braintree.TransactionLineItem.new/1","doc":"transaction_line_items =\n  Braintree.TransactionLineItem.new(%{\n    \"name\" => \"item name\",\n    \"total_amount\" => \"100.00\"\n})","ref":"Braintree.TransactionLineItem.html#new/1-example"},{"type":"type","title":"Braintree.TransactionLineItem.t/0","doc":"","ref":"Braintree.TransactionLineItem.html#t:t/0"},{"type":"module","title":"Braintree.UsBankAccount","doc":"UsBankAccount structs are not created directly, but are built within\nresponses from other endpoints, such as `Braintree.Customer`.","ref":"Braintree.UsBankAccount.html"},{"type":"function","title":"Braintree.UsBankAccount.new/1","doc":"","ref":"Braintree.UsBankAccount.html#new/1"},{"type":"type","title":"Braintree.UsBankAccount.t/0","doc":"","ref":"Braintree.UsBankAccount.html#t:t/0"},{"type":"module","title":"Braintree.Util","doc":"General purpose utility functions.","ref":"Braintree.Util.html"},{"type":"function","title":"Braintree.Util.atomize/1","doc":"Recursively convert a map of string keys into a map with atom keys. Intended\nto prepare responses for conversion into structs. Note that it converts any\nstring into an atom, whether it existed or not.\n\nFor unknown maps with unknown keys this is potentially dangerous, but should\nbe fine when used with known Braintree endpoints.","ref":"Braintree.Util.html#atomize/1"},{"type":"function","title":"Example - Braintree.Util.atomize/1","doc":"iex> Braintree.Util.atomize(%{\"a\" => 1, \"b\" => %{\"c\" => 2}})\n    %{a: 1, b: %{c: 2}}\n\n    iex> Braintree.Util.atomize(%{a: 1, b: %{\"c\" => 2}})\n    %{a: 1, b: %{c: 2}}","ref":"Braintree.Util.html#atomize/1-example"},{"type":"function","title":"Braintree.Util.hyphenate/1","doc":"Converts underscored values to hyphenated strings.","ref":"Braintree.Util.html#hyphenate/1"},{"type":"function","title":"Examples - Braintree.Util.hyphenate/1","doc":"iex> Braintree.Util.hyphenate(\"brain_tree\")\n    \"brain-tree\"\n\n    iex> Braintree.Util.hyphenate(:brain_tree)\n    \"brain-tree\"","ref":"Braintree.Util.html#hyphenate/1-examples"},{"type":"function","title":"Braintree.Util.underscorize/1","doc":"Converts hyphenated values to underscore delimited strings.","ref":"Braintree.Util.html#underscorize/1"},{"type":"function","title":"Examples - Braintree.Util.underscorize/1","doc":"iex> Braintree.Util.underscorize(\"brain-tree\")\n    \"brain_tree\"\n\n    iex> Braintree.Util.underscorize(:\"brain-tree\")\n    \"brain_tree\"","ref":"Braintree.Util.html#underscorize/1-examples"},{"type":"module","title":"Braintree.VenmoAccount","doc":"VenmoAccount structs are not created directly, but are built within\nresponses from other endpoints, such as `Braintree.Customer`.","ref":"Braintree.VenmoAccount.html"},{"type":"function","title":"Braintree.VenmoAccount.new/1","doc":"","ref":"Braintree.VenmoAccount.html#new/1"},{"type":"type","title":"Braintree.VenmoAccount.t/0","doc":"","ref":"Braintree.VenmoAccount.html#t:t/0"},{"type":"module","title":"Braintree.Webhook","doc":"This module provides convenience methods for parsing Braintree webhook payloads.","ref":"Braintree.Webhook.html"},{"type":"function","title":"Braintree.Webhook.parse/3","doc":"Return a map containing the payload and signature from the braintree webhook event.","ref":"Braintree.Webhook.html#parse/3"},{"type":"module","title":"Braintree.Webhook.Digest","doc":"This module provides convenience methods to help validate Braintree signatures and associated payloads for webhooks.","ref":"Braintree.Webhook.Digest.html"},{"type":"function","title":"Braintree.Webhook.Digest.hexdigest/2","doc":"Returns the message as a hex-encoded string to validate it matches the signature from the braintree webhook event.","ref":"Braintree.Webhook.Digest.html#hexdigest/2"},{"type":"function","title":"Braintree.Webhook.Digest.secure_compare/2","doc":"A wrapper function that does a secure comparision accounting for timing attacks.","ref":"Braintree.Webhook.Digest.html#secure_compare/2"},{"type":"module","title":"Braintree.Webhook.Validation","doc":"This module provides convenience methods to help validate Braintree signatures and associated payloads for webhooks.","ref":"Braintree.Webhook.Validation.html"},{"type":"function","title":"Braintree.Webhook.Validation.validate_signature/3","doc":"Validate the webhook signature and payload from braintree.","ref":"Braintree.Webhook.Validation.html#validate_signature/3"},{"type":"module","title":"Braintree.XML.Decoder","doc":"XML dumping tailored to encoding params sent by Braintree.","ref":"Braintree.XML.Decoder.html"},{"type":"function","title":"Braintree.XML.Decoder.load/1","doc":"Converts an XML document, or fragment, into a map. Type annotation\nattributes are respected, but all other attributes are ignored.","ref":"Braintree.XML.Decoder.html#load/1"},{"type":"function","title":"Examples - Braintree.XML.Decoder.load/1","doc":"iex> Braintree.XML.Decoder.load(\"  1  2  \")\n    %{\"a\" => %{\"b\" => 1, \"c\" => \"2\"}}\n\n    iex> Braintree.XML.Decoder.load(\"  Jos&#233;  \")\n    %{\"a\" => %{\"b\" => \"José\"}}\n\n    iex> Braintree.XML.Decoder.load(\"  First &amp; Last  \")\n    %{\"a\" => %{\"b\" => \"First & Last\"}}\n\n    iex> Braintree.XML.Decoder.load(\"  &quot;air quotes&quot;  \")\n    %{\"a\" => %{\"b\" => ~s(\"air quotes\")}}","ref":"Braintree.XML.Decoder.html#load/1-examples"},{"type":"type","title":"Braintree.XML.Decoder.xml/0","doc":"","ref":"Braintree.XML.Decoder.html#t:xml/0"},{"type":"module","title":"Braintree.XML.Encoder","doc":"XML encoding tailored to dumping Braintree compatible params.","ref":"Braintree.XML.Encoder.html"},{"type":"function","title":"Braintree.XML.Encoder.dump/1","doc":"Converts a map into the equivalent XML representation.","ref":"Braintree.XML.Encoder.html#dump/1"},{"type":"function","title":"Examples - Braintree.XML.Encoder.dump/1","doc":"iex> Braintree.XML.Encoder.dump(%{a: %{b: 1, c: 2}})\n    ~s|<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\\n \\n 1 \\n 2 \\n |\n\n    iex> Braintree.XML.Encoder.dump(%{a: %{b: \" \"}})\n    ~s|<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\\n \\n &lt;tag&gt; \\n |","ref":"Braintree.XML.Encoder.html#dump/1-examples"},{"type":"type","title":"Braintree.XML.Encoder.xml/0","doc":"","ref":"Braintree.XML.Encoder.html#t:xml/0"},{"type":"module","title":"Braintree.XML.Entity","doc":"XML entity conversion for known entities.","ref":"Braintree.XML.Entity.html"},{"type":"function","title":"Braintree.XML.Entity.decode/1","doc":"Replace all escaped HTML entities, except those that would produce invalid XML","ref":"Braintree.XML.Entity.html#decode/1"},{"type":"function","title":"Examples - Braintree.XML.Entity.decode/1","doc":"iex> Braintree.XML.Entity.decode(\"&lt;tag&gt;\")\n    \"&lt;tag&gt;\"\n\n    iex> Braintree.XML.Entity.decode(\"S&#248;ren\")\n    \"Søren\"\n\n    iex> Braintree.XML.Entity.decode(\"Normal\")\n    \"Normal\"\n\n    iex> Braintree.XML.Entity.decode(\"First &amp; Last\")\n    \"First &amp; Last\"\n\n    iex> Braintree.XML.Entity.decode(\"&quot;air quotes&quot;\")\n    ~s(\"air quotes\")","ref":"Braintree.XML.Entity.html#decode/1-examples"},{"type":"function","title":"Braintree.XML.Entity.encode/1","doc":"Encode all illegal XML characters by replacing them with corresponding\nentities.","ref":"Braintree.XML.Entity.html#encode/1"},{"type":"function","title":"Examples - Braintree.XML.Entity.encode/1","doc":"iex> Braintree.XML.Entity.encode(\" \")\n    \"&lt;tag&gt;\"\n\n    iex> Braintree.XML.Entity.encode(\"Here & There\")\n    \"Here &amp; There\"","ref":"Braintree.XML.Entity.html#encode/1-examples"},{"type":"exception","title":"Braintree.ConfigError","doc":"Raised at runtime when a config variable is missing.","ref":"Braintree.ConfigError.html"},{"type":"function","title":"Braintree.ConfigError.exception/1","doc":"Build a new ConfigError exception.","ref":"Braintree.ConfigError.html#exception/1"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"changelog.html"},{"type":"extras","title":"v0.16.0 - CHANGELOG","doc":"- [Braintree] Avoid a hackney 1.23.0 bug that compares the resolved server's IP address to the\n  certificate's host.\n\n  Without specifying the server_name_indication ssl option to hackney, it will result in this\n  error: \n\n  ```\n  {:error,\n   {:tls_alert,\n    {:handshake_failure,\n     ~c\"TLS client: In state hello received SERVER ALERT: Fatal - Handshake Failure\\n\"}}}\n  ```\n\n- [Braintree] Provide an escape hatch for the Braintree cacertfile by providing two new additional\n  configuration keys: cacertfile and sandbox_cacertfile. This is helpful in case the provided\n  cacertfile is expired, or for testing purposes.\n\n- [Braintree] Don't include SSL options for endpoints that aren't the official Braintree url.","ref":"changelog.html#v0-16-0"},{"type":"extras","title":"v0.15.0 - CHANGELOG","doc":"","ref":"changelog.html#v0-15-0"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- [Braintree] Update `api_braintreegateway_com.ca.crt`\n\n  This updates the client certificate to match the current Ruby SDK. Without\n  this update, requests won't be requested after June 30th, 2025.","ref":"changelog.html#changed"},{"type":"extras","title":"v0.14.0 - CHANGELOG","doc":"","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"Added - CHANGELOG","doc":"- [Braintree.VenmoAccount] Implements support for Venmo accounts","ref":"changelog.html#added"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"- [Braintree.*] Fix specs for functions returning HTTP errors\n\n  * Fix specs for functions returning HTTP errors\n  * Fix `Transaction` amount typespec and `ClientToken` compiler warning\n  * Make default amount same type as true typespec\n\n- [Braintree.ClientToken] Fix typespec on `ClientToken.generate/2`\n\n- [Braintree.Customer] Update `Customer.find/2` typespec\n\n- [Braintree.HTTP] Support common 5XX HTTP error statuses\n\n- [Braintree.Search] Include `:not_found` in search error typespec","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.13.0 2022-10-24 - CHANGELOG","doc":"","ref":"changelog.html#v0-13-0-2022-10-24"},{"type":"extras","title":"Added - CHANGELOG","doc":"- [Braintree.Webhook] Allow passing options to webhook parser/validator, similar\n  to other API functions.\n\n- [Braintree.Plan] Expand plan functionality with `delete`, improved guard\n  clauses, and better response code formatting.\n\n- [Braintree.Customer] Support ACH Direct Debit payment methods.","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- [Braintree.HTTP] Fix error in response type specification.\n\n  This typespec error wasn't caught given the current dialyzer settings, but\n  could cause issues for clients expecting things like `{:error, :not_found}`.","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.12.1 2021-11-18 - CHANGELOG","doc":"","ref":"changelog.html#v0-12-1-2021-11-18"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- Update CA certificate bundle and enable peer verification for all HTTP\n  requests.","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.12.0 2021-09-02 - CHANGELOG","doc":"","ref":"changelog.html#v0-12-0-2021-09-02"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Bumped the minium Elixir version from `1.7` to `1.9` (it had been a while!)","ref":"changelog.html#changed"},{"type":"extras","title":"Added - CHANGELOG","doc":"- [Braintree.Webhook] A new module that provides convenience methods for parsing\n  Braintree webhook payloads.\n\n- [Braintree] Wrap HTTP calls in telemetry events for instrumentation. All\n  requests are wrapped in a telemetry events, which emits standard span events:\n\n  `[:braintree, :request, :start | :stop | :exception | :error]`\n\n- [Braintree.Customer] Support ApplePay and AndroidPay","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- Fix atomizing nested maps with mixed keys.","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.11.0 2020-05-11 - CHANGELOG","doc":"* [Braintree] Allow configuration of sandbox endpoint for testing\n* [Braintree.CreditCard] Include `billing_address` with the `CreditCard` struct\n* [Braintree.Transaction] Add support for `android_pay_card` and correct field\n  names to match `android_pay_card` and `apple_pay`\n* [Braintree.Transaction] Rename `customer_details` to `customer` to correctly\n  reflect API results.\n* [Braintree.Search] Fix `perform` so that it correctly handles transaction\n  results\n* [Braintree.TestTransaction] Make TestTransaction available in all\n  environments.","ref":"changelog.html#v0-11-0-2020-05-11"},{"type":"extras","title":"v0.10.0 2019-03-26 - CHANGELOG","doc":"","ref":"changelog.html#v0-10-0-2019-03-26"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* [Braintree.HTTP] Support both `access_token` and public/private keys usage in configuration","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.9.0 2018-06-18 - CHANGELOG","doc":"","ref":"changelog.html#v0-9-0-2018-06-18"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* [Braintree] Use system tuples as the default for application env\n* [Braintree] Add dialyxer and fix all typespecs. Typespecs are now validated\n  during CI builds\n* [Braintree.HTTP] Expose `429 Too Many Requests` error with an integer to\n  status mapping\n* [Braintree.TestTransaction] The module is now available in all environments,\n  not just `test`\n* [Braintree.Address] Support added for address features\n* [Braintree.MerchantAccounts] Support added for merchant account features\n* [Braintree.Search] Support for searching customers, credit cards and\n  subscriptions\n* [Braintree.XML] Support collections when decoding XML responses","ref":"changelog.html#enhancements"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* [Braintree] Elixir 1.5 is now the minimum supported version\n* [Braintree.Transaction] Replace `:billing_details` with the correctly named\n  `:billing`","ref":"changelog.html#changes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* [Braintree.HTTP] Use `Keyword.get_lazy` to avoid exceptions when config keys\n  used for requests aren't set.\n* [Braintree.HTTP] Add explicit handling for `unprocessable_entity` errors\n* [Braintree.HTTP] Always coerce the environment to an atom","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.8.0 2017-08-24 - CHANGELOG","doc":"","ref":"changelog.html#v0-8-0-2017-08-24"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* [Braintree.ErrorResponse] Include full transaction details in the\n  `ErrorResponse` struct. This displays the underlying reason a request failed,\n  helping developers diagnose failing requests.\n* [Braintree.HTTP] Ability to optionally pass environment and API keys as\n  options to all functions doing API calls. The default behaviour of reading\n  from the global config is kept if those keys are not passed as arguments.\n  Submitted by @manukall and @nicolasblanco","ref":"changelog.html#enhancements"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* [Braintree.Construction] Use `new/1` to build structs, rather than the unusual\n  `construct/1` function.","ref":"changelog.html#changes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* [Braintree.HTTP] Catch and return `400 Bad Request` error tuples, rather than\n  generating a case clause error.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.7.0 2016-09-20 - CHANGELOG","doc":"","ref":"changelog.html#v0-7-0-2016-09-20"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* [Braintree.ClientToken] Set the default client token version to `2`.\n* [Braintree.Discount] Add support for discounts\n* [Braintree.AddOn] Add support for add-ons\n* [Braintree.SettlementBatchSummary] Add support for settlement reports\n* [Braintree.Subscription] Support updating with `update/2`\n* [Braintree.Subscription] Convert add-on and transaction lists to structs","ref":"changelog.html#enhancements"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* [Braintree.XML] Strictly accept maps for generation, not keyword lists.","ref":"changelog.html#changes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* [Braintree.XML] Correctly handle decoding entities such as `&amp;`, `&gt;`\n  and `&lt;`.\n* [Braintree.XML] Fix encoding XML array values\n* [Braintree.XML] Add encoding of binaries","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.6.0 2016-08-10 - CHANGELOG","doc":"","ref":"changelog.html#v0-6-0-2016-08-10"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* [Braintree.HTTP] Remove dependency on HTTPoison! Instead Hackney is used\n  directly.\n* [Braintree.HTTP] Configuration options can be provided for Hackney via\n  `http_options`.\n* [Braintree] Support `{:system, VAR}` for configs\n* [Braintree.XML] Support for parsing top level arrays. Some endpoints, notably\n  `plans`, may return an array rather than an object\n* [Braintree.Plan] Added module and `all/0` for retrieving billing plans\n* [Braintree.Customer] Enhanced with `find/1`\n* [Braintree.Subscription] Enhanced with `cancel/1` and `retry_charge/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* [Braintree.XML.Entity] XML entities are automatically encoded and decoded.\n  This prevents errors when values contain quotes, ampersands, or other\n  characters that must be escaped\n* [Braintree.Customer] Return a tagged error tuple for `delete/1`\n* [Braintree.Transaction] Use the correct `paypal` field for `Transaction` responses","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.5.0 2016-06-13 - CHANGELOG","doc":"* Added: Paypal endpoints for use with the vault flow [TylerCain]\n* Added: Construct Paypal accounts from customer responses\n* Added: Support `submit_for_settlement/2` to Transaction\n* Added: Typespec for the Transaction struct\n* Fixed: Typespec for the CreditCard struct\n* Fixed: Include xmerl in the list of applications to ensure that it is packaged\n  with `exrm` releases.","ref":"changelog.html#v0-5-0-2016-06-13"},{"type":"extras","title":"v0.4.0 2016-04-20 - CHANGELOG","doc":"* Added: Available only during testing, `TestTransaction`, which can be used to\n  transition transactions to different states.\n* Added: Add `find`, `void`, and `refund` on `Transaction`. [Tyler Cain]\n* Added: Add support for `PaymentMethod`, `PaymentMethodNonce`. [Tyler Cain]\n* Added: Basic support for subscription management, starting with `create`.\n  [Ryan Bigg]","ref":"changelog.html#v0-4-0-2016-04-20"},{"type":"extras","title":"v0.3.2 2016-02-26 - CHANGELOG","doc":"* Fixed: Log unprocessable responses rather than inspecting them to STDOUT.\n* Fixed: Convert 404 and 401 responses to error tuples, they are common problems\n  with misconfiguration.","ref":"changelog.html#v0-3-2-2016-02-26"},{"type":"extras","title":"v0.3.1 2016-02-18 - CHANGELOG","doc":"* Fixed: Lookup the certfile path at runtime rather than compile time. This\n  fixes potential build errors when pre-building releases or packaging on\n  platforms like Heroku.","ref":"changelog.html#v0-3-1-2016-02-18"},{"type":"extras","title":"v0.3.0 2016-02-17 - CHANGELOG","doc":"* Fixed: Raise helpful errors when missing required config\n* Added: Client token module for generating new client tokens [Taylor Briggs]","ref":"changelog.html#v0-3-0-2016-02-17"},{"type":"extras","title":"v0.2.0 2016-02-05 - CHANGELOG","doc":"* Added: Support for updating and deleting customers.\n* Added: A `Nonces` module for help testing transactions.\n* Changed: Include testing support `Braintree.Testing.CreditCardNumbers` as well as\n  `Braintree.Testing.Nonces` in `lib/testing`, making it available in packaged\n  releases.\n* Fixed: Trying to call `XML.load` on empty strings returns an empty map.\n* Removed: The `__using__` macro has been removed from HTTP because the naming\n  conflicted with `delete` actions. An equivalent macro will be introduced in\n  the future.","ref":"changelog.html#v0-2-0-2016-02-05"},{"type":"extras","title":"v0.1.0 2016-02-03 - CHANGELOG","doc":"* Initial release with support for `Customer.create` and `Transaction.sale`.","ref":"changelog.html#v0-1-0-2016-02-03"},{"type":"extras","title":"Braintree","doc":"# Braintree\n\n[![Build Status](https://travis-ci.org/sorentwo/braintree-elixir.svg?branch=master)](https://travis-ci.org/sorentwo/braintree-elixir)\n[![Hex version](https://img.shields.io/hexpm/v/braintree.svg \"Hex version\")](https://hex.pm/packages/braintree)\n[![Hex downloads](https://img.shields.io/hexpm/dt/braintree.svg \"Hex downloads\")](https://hex.pm/packages/braintree)\n[![Inline docs](https://inch-ci.org/github/sorentwo/braintree-elixir.svg)](https://inch-ci.org/github/sorentwo/braintree-elixir)\n\nA native [Braintree][braintree] client library for Elixir.\n\n[braintree]: https://www.braintreepayments.com","ref":"readme.html"},{"type":"extras","title":"Installation - Braintree","doc":"Add braintree to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:braintree, \"~> 0.13\"}]\nend\n```\n\nOnce that is configured you are all set. Braintree is a library, not an\napplication, but it does rely on `hackney`, which must be started. For Elixir\nversions < 1.4 you'll need to include it in the list of applications:\n\n```elixir\ndef application do\n  [applications: [:braintree]]\nend\n```\n\nWithin your application you will need to configure the merchant id and\nauthorization keys. You do *not* want to put this information in your\n`config.exs` file! Either put it in a `{prod,dev,test}.secret.exs` file which is\nsourced by `config.exs`, or read the values in from the environment in\n`runtime.exs`:\n\n```elixir\nconfig :braintree,\n  environment: :sandbox,\n  master_merchant_id: System.fetch_env!(\"BRAINTREE_MASTER_MERCHANT_ID\"),\n  merchant_id: System.fetch_env!(\"BRAINTREE_MERCHANT_ID\"),\n  public_key:  System.fetch_env!(\"BRAINTREE_PUBLIC_KEY\"),\n  private_key: System.fetch_env!(\"BRAINTREE_PRIVATE_KEY\")\n```\n\nFurthermore, the environment defaults to `:sandbox`, so you'll want to configure\nit with `:production` in `prod.exs`.\n\nBraintree has certificates that will be used for verification during the HTTP\nrequest. This library includes them and will use them by default, but if you\nneed to override them, you may provide the configuration `:cacertfile` and\n`:sandbox_cacertfile`.\n\nYou may optionally pass directly those configuration keys to all functions\nperforming an API call. In that case, those keys will be used to perform the\ncall.\n\nYou can optionally [configure Hackney options][opts] with:\n\n```elixir\nconfig :braintree,\n  http_options: [\n    timeout: 30_000, # default, in milliseconds\n    recv_timeout: 5000 # default, in milliseconds\n  ]\n```\n\n[opts]: https://hexdocs.pm/hackney/hackney.html#request/5","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Braintree","doc":"The online [documentation][doc] for Ruby/Java/Python etc. will give you a\ngeneral idea of the modules and available functionality. Where possible the\nnamespacing has been preserved.\n\nThe CRUD functions for each action module break down like this:\n\n```elixir\nalias Braintree.Customer\nalias Braintree.ErrorResponse, as: Error\n\ncase Customer.create(%{company: \"Whale Corp\"}) do\n  {:ok, %Customer{} = customer} -> do_stuff_with_customer(customer)\n  {:error, %Error{} = error}    -> do_stuff_with_error(error)\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Searching - Braintree","doc":"Search params are constructed with a fairly complex structure of maps. There\nisn't a DSL provided, so queries must be constructed by hand. For example, to\nsearch for a customer:\n\n```elixir\nsearch_params = %{\n  first_name: %{is: \"Jenna\"},\n  last_name: %{\n    starts_with: \"Smith\",\n    contains: \"ith\",\n    is_not: \"Smithsonian\"\n  },\n  email: %{ends_with: \"gmail.com\"}\n}\n\n{:ok, customers} = Braintree.Customer.search(search_params)\n```\n\nOr, to search for pending credit card verifications within a particular dollar\namount:\n\n```elixir\nsearch_params = %{\n  amount: %{\n    min: \"10.0\",\n    max: \"15.0\"\n  },\n  status: [\"approved\", \"pending\"]\n}\n\n{:ok, verifications} = Braintree.CreditCardVerification.search(search_params)\n```\n\n[doc]: https://developers.braintreepayments.com/","ref":"readme.html#searching"},{"type":"extras","title":"Telemetry - Braintree","doc":"If the `telemetry` application is running, the library will emit telemetry events.\n\nImmediately before the HTTP request is fired, a start event will be fired with the following shape:\n\n```\n event name:    [:braintree, :request, :start]\n measurements:  %{system_time: System.system_time()}\n meta data:     %{method: method, path: path}\n```\n\nOnce the HTTP call completes, a stop event will be fired with the following shape:\n\n```\n event name:    [:braintree, :request, :stop]\n measurements:  %{duration: duration}\n meta data:     %{method: method, path: path, http_status: status}\n```\n\nIf Hackney returns an error, an error event will be fired with the following shape:\n\n```\n event name:    [:braintree, :request, :error]\n measurements:  %{duration: duration}\n meta data:     %{method: method, path: path, error: error_reason}\n```\n\nIf an exception is raised during the Hackney call, an exception event will be fired with the following shape:\n\n```\n event name:    [:braintree, :request, :exception]\n measurements:  %{duration: duration}\n meta data:     %{method: method, path: path, kind: error_type, reason: error_message, stacktrace: stacktrace}\n```","ref":"readme.html#telemetry"},{"type":"extras","title":"Testing - Braintree","doc":"You'll need a Braintree sandbox account to run the integration tests. Also, be\nsure that your account has [Duplicate Transaction Checking][dtc] disabled.","ref":"readme.html#testing"},{"type":"extras","title":"Merchant Account Features - Braintree","doc":"In order to test the merchant account features, your sandbox account needs to\nhave a master merchant account and it needs to be added to your environment\nvariables (only needed in test).\n\nYour environment needs to have the following:\n\n* Add-ons with ids: \"bronze\", \"silver\" and \"gold\"\n* Plans with ids: \"starter\", \"business\"\n* \"business\" plan needs to include the following add-ons: \"bronze\" and \"silver\"","ref":"readme.html#merchant-account-features"},{"type":"extras","title":"PayPal Account Testing - Braintree","doc":"PayPal testing uses the mocked API flow, which requires linking a sandbox PayPal\naccount. You can accomplish that by following the directions for [linked paypal\ntesting][plp].\n\n[dtc]: https://articles.braintreepayments.com/control-panel/transactions/duplicate-checking\n[plp]: https://developers.braintreepayments.com/guides/paypal/testing-go-live/php#linked-paypal-testing","ref":"readme.html#paypal-account-testing"},{"type":"extras","title":"Testing Using Only `localhost` - Braintree","doc":"You can optionally configure the sandbox endpoint url to point towards a local url and\nport for testing which does not need to call out to the Braintree sandbox API.\nFor example, in your `config.exs`\n\n```elixir\nconfig :braintree, :sandbox_endpoint, \"localhost:4001\"\n```\n\nIn conjuction with a libary such as [`Bypass`](https://github.com/PSPDFKit-labs/bypass)\nyou can use this config to define test-specific returns from `Braintree` calls without\nhitting the Braintree sandbox API.","ref":"readme.html#testing-using-only-localhost"},{"type":"extras","title":"License - Braintree","doc":"MIT License, see [LICENSE.txt](LICENSE.txt) for details.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}